class AppManager {

      constructor() {
            this.debugMode = true;

            this.loadingElements = new Array('window', 'document');
            if (typeof cordova !== 'undefined') { this.loadingElements.push('device'); }

            document.addEventListener('DOMContentLoaded', ()=> { this.loadElement('document'); }, false);
            window.addEventListener('load', ()=> { this.loadElement('window'); }, false);
            document.addEventListener('deviceready', ()=> { this.loadElement('device'); }, false);
      }

      /* APPLOG */
      applog(msg) {

            if (this.debugMode) {
      
                  if (document.getElementById('applog')===null) {
                        let applog = document.createElement('div');
                        applog.id = 'applog';
                        document.body.appendChild(applog);
                  }
            
                  console.log(msg);
                  document.getElementById('applog').innerHTML += msg + '<br>';
            }
      }
      apperror(msg) {
            this.applog(msg);
            displayModal('error', msg);
      }
      appsuccess(msg) {
            this.applog(msg);
            displayModal('success', msg);
      }
      
      loadElement(what) {

            let index = this.loadingElements.indexOf(what);
            if (index>=0) {
                  this.loadingElements.splice(index, 1);
            }

            if (this.loadingElements.length==0) {
                  this.applog('startApp');
                  setTimeout(()=> { this.startApp(); }, 1000);
            }

      }

      startApp() {

            // adapt viewport
            adaptViewport();
        
            // remove loading modal
            document.getElementById('modal_loading').className = 'modal_container disappear';
           
            // create folder
            if (typeof cordova !== 'undefined') {
                myFileManager.initFolder();
            }
        
            // create image processor
            myImgProcessor = new ImageProcessor();

            // translate
            myTranslator   = new Translator();
        
      }

}

