
/* FORM */
document.getElementById('clear').onclick = function(event) { 
      event.target.className = 'processing'; 
      document.getElementById('results').innerHTML = ''; 	
      setTimeout(function() { event.target.className = ''; }, 100); 
}

document.getElementById('process').onclick = function(event) { myImgProcessor.processForm(event); }

document.getElementById('saveall').onclick = function(event) { 
      saveAll();
}

/* DROP */
if (typeof cordova === 'undefined') {
      document.addEventListener("dragover", function(event) {
            event.preventDefault();
      });
      document.body.addEventListener('drop', function(event) {
            event.preventDefault();
            myImgProcessor.processForm(event);
      });
}

/* DEBUG DISPLAY */
document.getElementsByTagName('h1')[0].onclick = function(event) {

      let tCount = event.target.getAttribute('data-count');
      if (tCount===null) {
          tCount = 2;
      } else if (tCount==7) {
  
          if (document.getElementById('applog').className=='') {
              document.getElementById('applog').className = 'display';
              document.getElementById('footer').style.display = 'none';
              
              document.body.className = 'debugmode';
          } else {
              document.getElementById('applog').className = '';
              document.getElementById('footer').style.display = 'block';
              
              document.body.className = '';
          }
  
          tCount = 1;
      } else {
          tCount++;
      }
  
      event.target.setAttribute('data-count', tCount);    
  
}

  
/* COLOR PICKER */
document.getElementById('color_picker').onclick = function(event) {
      myApp.applog('pick color');
      document.getElementById('modal_color_picker').className = 'modal_container appear';
      document.getElementById('resize_full').checked = true;
}
document.querySelectorAll('#modal_color_picker .content>div').forEach(
      function(elem) {
          elem.onclick = function(event) {
              document.querySelectorAll('#modal_color_picker .content>div').forEach(function(elem) { elem.className = ''; });
              event.target.className = 'selected';
              
              let tColor = event.target.style.backgroundColor;
  
              document.getElementById('input_color').value = tColor;
              document.getElementById('color_picker').style.backgroundColor = tColor;
          }
      }
);
  
/* MODAL */
function displayModal(type, msg) {
  
      let tModalDOM = document.getElementById('modal_standard');
      tModalDOM.querySelector('h2').innerHTML = type.toUpperCase();
      tModalDOM.querySelector('.content').innerHTML = '<img src="img/'+type+'.svg"><br>'+msg;    
      tModalDOM.className = 'modal_container appear';
  
}
  
document.addEventListener('click', function (event) {
  
      // If the clicked element doesn't have the right selector, bail
      if (!event.target.matches('.modal button')) return;
  
      event.target.closest('.modal_container').className = 'modal_container disappear';   
  
});

// SLIDER //
document.getElementById('input_quality').oninput = function(event) {
      document.getElementById('input_quality_percent').value = Math.round(event.target.value*100)+'%';
};
document.getElementById('input_quality_percent').onchange = function(event) {
      let tValue = event.target.value;
      tValue = parseInt(tValue);
      if (isNaN(tValue)===true) { tValue = 0; }
      tValue = Math.min(tValue, 100);
      tValue = Math.max(tValue, 0);
      event.target.value = tValue+'%';
      tValue = tValue / 100;
      document.getElementById('input_quality').value = tValue;
}

/* PRESELECT SIZING */
document.getElementById('preselect').onchange = function(event) {
      let tPreset = event.target.value;
      switch(tPreset) {
          case 'auto': 
              document.getElementById('input_width').value = 'auto';
              document.getElementById('input_height').value = 'auto';
              break;
          case 'width_1920': 
              document.getElementById('input_width').value = '1920';
              document.getElementById('input_height').value = 'auto';
              break;
          case 'height_1080': 
              document.getElementById('input_width').value = 'auto';
              document.getElementById('input_height').value = '1080';
              break;
          case 'hd': 
              document.getElementById('input_width').value = '1920';
              document.getElementById('input_height').value = '1080';
              break;
            case 'hd_ready': 
              document.getElementById('input_width').value = '1280';
              document.getElementById('input_height').value = '720';
              break;
          case 'ld': 
              document.getElementById('input_width').value = '640';
              document.getElementById('input_height').value = '480';
              break;
      }
      event.target.selectedIndex = 0;
}

document.querySelectorAll('input[name="format"]').forEach(input=> {
      input.addEventListener('change', (e)=> {
            let tDisplayQuality = (input.id==='format_jpg') ? 'block':'none';
            document.getElementById('quality_container').style.display = tDisplayQuality;
      });
});

/* VIEWPORT */
window.addEventListener('resize', function(event) {
      adaptViewport();
});
function adaptViewport() {

      if (window.MobileAccessibility) {
            window.MobileAccessibility.usePreferredTextZoom(false);
      }

      let tAppWidthCSS = window.getComputedStyle(document.body).getPropertyValue('width');
      let tAppWidthPx = parseInt(tAppWidthCSS);
      myApp.applog('body width ' + tAppWidthCSS+' '+tAppWidthPx);

      if (tAppWidthCSS.indexOf('px') >= 0 && tAppWidthPx<640) {
            // SCREEN //
            
            let tViewWidth = window.innerWidth;                           
            let tTransformRatio = tViewWidth / tAppWidthPx;
            
            myApp.applog('Viewport ratio=' + tTransformRatio + ' (' + tViewWidth + '/' + tAppWidthPx + ')');
            
            // SCALE //
            document.getElementById('app').style.transform = 'scale(' + tTransformRatio + ')';
            document.getElementById('app').style.transformOrigin = 'top left';
            
      } else {
            document.getElementById('app').style.transform = 'none';
      }
}

/* SAVE */
let savingImages = 0;
function saveAll() {

      if (document.getElementById('saveall').classList.contains('processing')) {
            myApp.apperror('Please wait for end of current process');
            return false; 
      }

      document.getElementById('saveall').classList.add('processing');

      if (typeof cordova !== 'undefined') {
            // loop save
            myApp.applog('nb links = '+document.querySelectorAll('#results div.links>a[data-type="save"]').length);
            
            setTimeout(()=>{
                  document.querySelectorAll('#results div.links>a[data-type="save"]').forEach((link, i)=> {
                        savingImages++;
                        setTimeout(()=>{
                              myApp.applog('link filename : '+link.getAttribute('download'));
                              link.dispatchEvent(new MouseEvent('click', { bubbles: true }));
                        }, 250*i);            
                  });                  
            }, 250);            
            
      } else {
            // save as zip

            var zip = new JSZip();
            //var img = zip.folder("images");
            let tSaveLinks = document.querySelectorAll('#results div.links>a[data-type="save"]');
            tSaveLinks.forEach((link)=> {                  
                  let filename = link.getAttribute('download');

                  let myBaseString = link.getAttribute('href');
                  // Split the base64 string in data and contentType
                  let block = myBaseString.split(";");                  
                  // get the real base64 content of the file
                  let realData = block[1].split(",")[1];// In this case "iVBORw0KGg...."

                  zip.file(filename, realData, {base64: true});
            });
            zip.generateAsync({type:"blob"})
            .then(function(content) {     
                  
                  // see FileSaver.js
                  let tDate = new Date();
                  let tNB = tSaveLinks.length;
                  saveAs(content, "Images_compress "+tDate.toISOString().substring(0, 10)+" ("+tNB+" items).zip");     
                  
                  setTimeout(()=>{
                        document.getElementById('saveall').classList.remove('processing');
                  }, 250);

            });
      }
}
function saveLinkAsFile(link) {

      let myBaseString = link.getAttribute('href');
      // Split the base64 string in data and contentType
      let block = myBaseString.split(";");
      // Get the content type
      let dataType = block[0].split(":")[1];// In this case "image/png"
      // get the real base64 content of the file
      let realData = block[1].split(",")[1];// In this case "iVBORw0KGg...."

      if (link.getAttribute('data-type')=='share') {
            // USE SHARE PLUGIN
            let tMessage = myTranslator.translate('Check out this image compressed with Resize&Compress!');
            let tSubject = myTranslator.translate('Compressed image') + ' : '+ link.getAttribute('download');
            let tURL = null;
            window.plugins.socialsharing.share(tMessage, tSubject, myBaseString, tURL);
            return true;
      }

      // The path where the file will be created
      let filename = link.getAttribute('download');
      myFileManager.savebase64AsImageFile('', filename, realData, dataType);  

      savingImages--;
      if (savingImages===0) {
            document.getElementById('saveall').classList.remove('processing');
      }

}
if (typeof cordova !== 'undefined') {

      document.addEventListener('click', function (event) {

            myApp.applog('document heard a click');

            // If the clicked element doesn't have the right selector, bail
            if (!event.target.matches('#results div.links>a')) { return false; }

            // Don't follow the link
            event.preventDefault();

            // Log the clicked element in the console
            myApp.applog('click on '+event.target.href+' '+event.target.getAttribute('data-type'));

            saveLinkAsFile(event.target);         

      }, false);
}

// LANGUAGES
document.querySelectorAll('#footer button').forEach((elem)=> {
      elem.onclick = function(event) {
            console.log(elem);
            let tLang = elem.getAttribute('data-lang');
            myTranslator.setLanguage(tLang);
      }
});