class Translator {
      constructor() {

            this.dictionnary = {'en':
                  {
                        "Format":"Format", 
                        "Quality":"Quality", 
                        "Sizes":"Sizes", 
                        "Preset":"Preset", 
                        "Select a preset format":"Select a preset format",
                        "Original":"Original", 
                        "1920 Width":"1920 Width", 
                        "1080 Height":"1080 Height", 
                        "Width":"Width", 
                        "Height":"Height", 
                        "Resizing method":"Resizing method", 
                        "Crop":"Crop", 
                        "Deform":"Deform", 
                        "Color filling":"Color filling", 
                        "Rotation":"Rotation", 
                        "None":"None", 
                        "90° right":"90° right", 
                        "90° left":"90° left", 
                        "Files":"Files", 
                        "Now loading, please wait...":"Now loading, please wait...", 
                        "Pick a color":"Pick a color",
                        "Process":"Process",
                        "Clear results":"Clear results",
                        "Processing":"Processing",
                        "Step":"Step",
                        "Reading file":"Reading file",
                        "Loading image":"Loading image",
                        "Processing image":"Processing image",
                        "From":"From",
                        "To":"To",
                        "Save file":"Save file",
                        "Share file":"Share file",
                        "Check out this image compressed with Resize&Compress!": "Check out this image compressed with Resize&Compress!",
                        "Compressed image": "Compressed image",
                        "Save all processed": "Save all processed"
                  }
            , 
            'fr':                  
                  {
                        "Format":"Format",
                        "Quality":"Qualité",
                        "Sizes":"Tailles",
                        "Preset":"Prédéfinies",
                        "Select a preset format":"Sélection d'un format prédéfini",
                        "Original":"Originale",
                        "1920 Width":"1920 Large",
                        "1080 Height":"1080 Haut",
                        "Width":"Largeur",
                        "Height":"Hauteur",
                        "Resizing method":"Retaillage",
                        "Crop":"Coupe",
                        "Deform":"Déforme",
                        "Color filling":"Remplis",
                        "Rotation":"Rotation",
                        "None":"Sans",
                        "90° right":"90° droite",
                        "90° left":"90° gauche",
                        "Files":"Fichiers",
                        "Now loading, please wait...":"Chargement en cours...",
                        "Pick a color":"Choisir une couleur",
                        "Process":"Compresser",
                        "Clear results":"Effacer",
                        "Processing":"Traitement",
                        "Step":"Étape",
                        "Reading file":"Lecture du fichier",
                        "Loading image":"Chargement de l'image",
                        "Processing image":"Traitement de l'image",
                        "From":"De",
                        "To":"À",
                        "Save file":"Sauvegarder",
                        "Share file":"Partager",
                        "Check out this image compressed with Resize&Compress!": "Regardez cette image compressée avec Resize&Compress !",
                        "Compressed image": "Image compressée",
                        "Save all processed": "Enregistrer tous les résultats"
                  }
            };

            this.currentLanguage = '';

            this.setLanguage(navigator.languages[0].substring(0, 2).toLowerCase());

      }

      translateDOM() {
            let tElements = document.getElementsByClassName('translate');
            for(let elem of tElements) {

                  let tRef = elem.getAttribute('data-translate');
                  if (tRef===null) {
                        if (elem.tagName==='INPUT') {
                              if (elem.type==='button') {
                                    tRef = elem.value;  
                              } else {
                                    tRef = elem.placeholder;  
                              }                                              
                        } else {
                              tRef = elem.innerHTML;
                        }
                        elem.setAttribute('data-translate', tRef);
                  }

                  let tTranslated = this.translate(tRef);

                  if (elem.tagName==='INPUT') {                      
                        if (elem.type==='button') {
                              elem.value = tTranslated;
                        } else {
                              elem.placeholder = tTranslated;
                        }  
                  } else {
                        elem.innerHTML = tTranslated;
                  }

            };
      }

      translate(ref, transform='') {

            let tTranslated = ref;
            if (this.dictionnary[this.currentLanguage].hasOwnProperty(ref)) {
                  tTranslated = this.dictionnary[this.currentLanguage][ref];
            } else {
                  this.dictionnary[this.currentLanguage][ref] = ref;
            }

            return tTranslated;

      }
      setLanguage(lang) {

            console.log(lang);

            this.currentLanguage = lang;

            if (['fr', 'en'].some((elem)=>this.currentLanguage===elem)===false) {
                  this.currentLanguage = 'en';
            }

            this.translateDOM();
      }
}